/********************************************************
 * Count -- test a module to count the number of key	*
 *		integers in an array.  			*
 *							*
 * Programming problem: 9-3				*
 *							*
 * Usage:						*
 *	Run the program, check the results		*
 *							*
 * Algorithm: We deliberately use recursion to solve	*
 * this problem.  This not the most efficient 		*
 * algorithm, but it the most interesting.		*
 ********************************************************/
#include <iostream.h>

/********************************************************
 * count_one -- look for a integer in an array		*
 *							*
 * Returns						*
 *	number of times "key" appears in "array"	*
 *	from the elements "start" to "end"-1		*
 ********************************************************/
int count_one(
    const int key,	// Key number
    const int array[],	// Array to look at
    const int start,	// Starting index
    const int end	// Ending index
)
{
    // Nothing to count means nothing to match
    if (start >= end)
	return (0);

    if (array[start] == key)
	return (1+ count_one(key, array, start+1, end));
    else
	return (   count_one(key, array, start+1, end));
}
/********************************************************
 * count -- count the number of key elements in an array*
 *							*
 * Returns						*
 *	number of times "key" appears in "array"	*
 ********************************************************/
int count(
    const int key,	// Key value to look for
    const int array[],	// Array to look at
    const int length	// length of the array
)
{
    return (count_one(key, array, 0, length));
}

// Test data         1  2  3  4  5  6  7  8  9
const int test1[] = {4, 5, 8, 9, 8, 1, 2, 2, 0};
const int test2[] = {6, 3, 7, 7, 3, 9, 1, 1, 9};

main()
{
    cout << "Test 1 result " << count(2, test1, 9) << '\n';
    cout << "Test 2 result " << count(7, test2, 9) << '\n';
    cout << "Test 3 result " << count(4, test1, 9) << '\n';
    cout << "Test 4 result " << count(1, test2, 9) << '\n';
    return (0);
}
