/********************************************************
 * words -- Break a line into words.			*
 *							*
 * A word is defined as any series of letters bounded	*
 * on both ends by an non-letter or the string beginning*
 * or end.						*
 *							*
 * Programming problem: 9-1.				*
 *							*
 * Usage:						*
 *	Run the program.				*
 *	Enter the string				*
 *	Get the words.					*
 ********************************************************/
#include <iostream.h>

/********************************************************
 * isletter -- return true if the character is a letter	*
 *							*
 * Note: This function duplicates the standard function	*
 * isletter.						*
 *							*
 * We use "int" instead of "bool" because "bool" is not	*
 * universally used yet.				*
 ********************************************************/
int isletter(
   const char ch
)
{
    return (((ch >= 'a') && (ch <= 'z')) ||
	    ((ch >= 'A') && (ch <= 'Z')));
}

main()
{
    const int LINE_MAX = 256;	// Maximum length of a line 
				// (and a word).
    char line[LINE_MAX];	// The input line
    int line_index;		// Index into the line

    char word[LINE_MAX];	// Current word
    int word_index;		// Index into the word

    cout << "Enter a line: ";
    cin.getline(line, sizeof(line));

    for (line_index = 0; line[line_index] != '\0'; ++line_index) {

	// See if we've got a word start
	if (isletter(line[line_index])) {
	    /*
	     * Copy word from "line" to to "word"
	     */
	    for (word_index = 0; isletter(line[line_index]); ++word_index) {
		word[word_index] = line[line_index];
		++line_index;
	    }
	    word[word_index] = '\0';
	    cout << "Word: " << word << '\n';

	    // Get out if out of data
	    if (line[line_index] == '\0')
		break;
	}
    }
    return (0);
}
