/********************************************************
 * phd -- Test a class for boarding Pigs, Horses, and	*
 *		dogs.					*
 *							*
 * Programming problem: 14-2				*
 ********************************************************/
#include <iostream.h>

/********************************************************
 * pig -- pig boarding class (incomplete)		*
 *							*
 * Member functions:					*
 *	board -- board a new pig			*
 *	remove -- remove a pig from boarding.		*
 ********************************************************/
class pig {
    private:
	static int boarded;	// Number of pigs boards
    public:
	pig(void) {}		// Default constructor
	// Destructor defaults
    private:
	pig(const pig &);	// No copy constructor
	pig operator =(const pig &); // No assignment operator
    public:
	// Board a new pig
	void board(void) {
	    ++boarded;
	}
	// Remove an animal from being boarded
	void remove(void) {
	    --boarded;
	}
    friend const int total_boarded(void);
};

/********************************************************
 * horse -- horse boarding class (incomplete)		*
 *							*
 * Member functions:					*
 *	board -- board a new horse			*
 *	remove -- remove a horse from boarding.		*
 ********************************************************/
class horse {
    private:
	static int boarded;	// Number of horses boards
    public:
	horse(void) {}		// Constructor defaults
	// Destructor defaults
    private:
	horse(const horse &);	// No copy constructor
	horse operator =(const horse &); // No assignment operator
    public:
	// Board a new horse
	void board(void) {
	    ++boarded;
	}
	// Remove an animal from being boarded
	void remove(void) {
	    --boarded;
	}
    friend const int total_boarded(void);
};
/********************************************************
 * dog -- dog boarding class (incomplete)		*
 *							*
 * Member functions:					*
 *	board -- board a new dog			*
 *	remove -- remove a dog from boarding.		*
 ********************************************************/
class dog {
    private:
	static int boarded;	// Number of dogs boards
    public:
	dog(void) {} 		// Default constructor
	// Destructor defaults
    private:
	dog(const dog &);	// No copy constructor
	dog operator =(const dog &); // No assignment operator
    public:
	// Board a new dog
	void board(void) {
	    ++boarded;
	}
	// Remove an animal from being boarded
	void remove(void) {
	    --boarded;
	}
    friend const int total_boarded(void);
};

int pig::boarded = 0;	// Number of pigs now boarded
int horse::boarded = 0;	// Number of horses now boarded
int dog::boarded = 0;	// Number of dogs now boarded

/********************************************************
 * total_boarded -- Return the total number of pigs	*
 *	horses, and dogs boarded.			*
 ********************************************************/
inline const int total_boarded(void)
{
   return (pig::boarded + horse::boarded + dog::boarded);
}

main()
{
   pig pig_pen;		// Place to put pigs
   horse horse_barn;	// Place to put horses
   dog dog_kennel;	// Place to put dogs

   pig_pen.board();	// Board a pig
   pig_pen.board();	// Board another pig

   cout << "Total boarded is " << total_boarded() << '\n';

   horse_barn.board();	// Board a horse

   cout << "Total boarded is " << total_boarded() << '\n';

   dog_kennel.board();	// Board a pig
   dog_kennel.board();	// Board another pig

   cout << "Total boarded is " << total_boarded() << '\n';
   return (0);
}
