/********************************************************
 * two -- a demonstration of a function to see if 	*
 *	one of two classes is using a file.		*
 *							*
 * Programming Problem: 14-1.				*
 *							*
 * Note: This is a demonstration program and does not	*
 * resemble real code.  Pieces are missing out of our	*
 * two classes.						*
 ********************************************************/
#include <iostream.h>

/********************************************************
 * A class that uses a file.				*
 *							*
 * Member functions:					*
 *	use_file -- Use the file.			*
 *	unuse_file -- Finish with the file		*
 *	...						*
 ********************************************************/
class first {
    private:
	static int use_count;	// Number of times we have the file open

    public:
	// Constructor defaults
	// Destructor defaults
	// Copy constructor defaults
	// Assignment operator defaults
	
	void use_file(void) {
	    ++use_count;
	}
	void unuse_file(void) {
	    --use_count;
	}
    friend int check_file(void);
};

int first::use_count = 0;	// First is not using the file yet
	
/********************************************************
 * A class that uses a file.				*
 *	At first glance this would appear to be a copy	*
 *	of first.  It is, except for the parts we 	*
 *	haven't filled in yet.				*
 *							*
 * Member functions:					*
 *	use_file -- Use the file.			*
 *	unuse_file -- Finish with the file		*
 *	...						*
 ********************************************************/
class second {
    private:
	static int use_count;	// Number of times we have the file open

    public:
	// Constructor defaults
	// Destructor defaults
	// Copy constructor defaults
	// Assignment operator defaults
	
	void use_file(void) {
	    ++use_count;
	}
	void unuse_file(void) {
	    --use_count;
	}
    friend int check_file(void);
};
      
int second::use_count = 0;	// Second is not using the file yet

/********************************************************
 * check_file -- check to see if the file is in use	*
 *							*
 * Returns						*
 *	1 -- file is in use				*
 *	0 -- file is not in use				*
 ********************************************************/
inline int check_file(void)
{
   return ((first::use_count > 0) || (second::use_count > 0));
}

main()
{
    cout << "File in use: " << check_file() << '\n';

    first a_first;	// Define a test variable
    second a_second;	// Define a test variable

    a_first.use_file();
    cout << "File in use: " << check_file() << '\n';

    a_second.use_file();
    cout << "File in use: " << check_file() << '\n';

    a_first.unuse_file();
    cout << "File in use: " << check_file() << '\n';

    a_second.unuse_file();
    cout << "File in use: " << check_file() << '\n';
  
    return (0);
}
