/********************************************************
 * fixed -- fixed point arithmetic class.		*
 *	And test program.				*
 *							*
 * Programming Problem: 19-2				*
 ********************************************************/
#include <iostream.h>

const unsigned int SCALE = 100;	// Fixed point scale factor

/********************************************************
 * Fixed Point class					*
 *							*
 * Members defined					*
 *	fixed_point()		// Default constructor	*
 *	fixed_point(float)	// Initializing 	*
 *				// constructor		*
 *				// for construction	*
 *							*
 * Operator member functions				*
 *			fp -- a fixed_point number	*
 *			s -- a scalar (double)		*
 *	fp = fp						*
 *	fp += fp;					*
 *	fp += s;					*
 *	fp -= fp;					*
 *	fp -= s;					*
 *	fp /= fp;					*
 *	fp /= s;					*
 *	fp *= fp;					*
 *	fp *= s;					*
 *	fp++						*
 *	++fp						*
 *	fp--						*
 *	--fp						*
 *							*
 * Arithmetic operators defined				*
 *							*
 *	fp = fp + fp;					*
 *	fp = s + fp;					*
 *	fp = fp + s;					*
 *	fp = fp - fp;					*
 *	fp = s - fp;					*
 *	fp = fp - s;					*
 *	fp = fp * fp;					*
 *	fp = s * fp;					*
 *	fp = fp * s;					*
 *	fp = fp / fp;					*
 *	fp = s / fp;					*
 *	fp = fp / s;					*
 *	-fp						*
 *	+fp						*
 *	ostream << fp	// Output function		*
 *	istream >> fp	// Input function		*
 ********************************************************/
class fixed_point {
    private:
        int value;	// Value * 100
    public:
        fixed_point(void) { value = 0;}
	fixed_point(float i_value) { 
	    value = int(i_value * double(SCALE)); 
	}
	// Destructor defaults
	// Copy constructor defaults
	// Assignment operator defaults

	void set(const double new_value) {
	    value = int(new_value * double(SCALE));
	}

	double get(void) {
	    return (double(value) / double (SCALE));
	}

	fixed_point& operator += (const fixed_point& oper2) {
	   value += oper2.value;
	   return (*this);
	}

	fixed_point& operator += (const double oper2) {
	   value += int(oper2 * double(SCALE));
	   return (*this);
	}

	fixed_point& operator -= (const fixed_point& oper2) {
	   value -= oper2.value;
	   return (*this);
	}

	fixed_point& operator -= (const double oper2) {
	   value -= int(oper2 * double(SCALE));
	   return (*this);
	}

	fixed_point& operator *= (const fixed_point& oper2) {
	   value = 
	      int(double(value) * double(oper2.value) / double(SCALE));
	   return *this; 
	}

	fixed_point& operator *= (double oper2) {
	   value = int(value * (oper2 / double(SCALE)) / double(SCALE));
	   return (*this);
	}

	fixed_point& operator /= (const fixed_point& oper2) {
	   value = 
	      int(double(value) / double(oper2.value) * double(SCALE));
	   return (*this);
	}
	    

	fixed_point& operator /= (double oper2) {
	   value = 
	      int(double(value) / (oper2 / double(SCALE)) * double(SCALE));
	   return (*this);
	}

	// fp++
	fixed_point operator ++(int) {
	   fixed_point result(*this);
	   value += SCALE;
	   return (result);
	}

	// ++fp
	fixed_point &operator ++(void) {
	   value += SCALE;
	   return (*this);
	}

	// fp--
	fixed_point operator --(int) {
	   fixed_point result(*this);
	   value -= SCALE;
	   return (result);
	}

	// --fp
	fixed_point &operator --(void) {
	   value -= SCALE;
	   return (*this);
	}
    friend inline fixed_point operator + (
	const fixed_point& oper1, 
	const fixed_point& oper2
    );

    friend inline fixed_point operator - (
	const fixed_point& oper1, 
	const fixed_point& oper2
    );

    friend fixed_point operator / (
	const fixed_point &oper1, 
	const fixed_point &oper2
    );

    friend inline fixed_point operator * (
	const fixed_point& oper1, 
	const fixed_point& oper2
    );

    friend inline ostream &operator << (
       ostream &out_file, 
       const fixed_point &number
    );
    friend istream &operator >> (
	istream &in_file, 
	fixed_point &number
    );
    friend inline fixed_point operator - (const fixed_point& oper1);

    friend inline int operator == (
	const fixed_point& oper1, 
	const fixed_point& oper2
    );
    friend inline int operator != (
	const fixed_point& oper1, 
	const fixed_point& oper2
    );
};

/********************************************************  
 * fixed +  fixed  -- Addition 				*
 *							*
 * Returns:						*
 *	The result of the addition			*
 ********************************************************/
inline fixed_point operator + (
    const fixed_point& oper1, 	// First number to add
    const fixed_point& oper2	// Second number to add
)
{
  fixed_point result;		// Result of the addition

  result.value = oper1.value + oper2.value;
  return (result);
}

/********************************************************  
 * fixed +  double  -- Addition 			*
 *							*
 * Returns:						*
 *	The result of the addition			*
 ********************************************************/
inline fixed_point operator + (
    const fixed_point& oper1, 	// First number to add
    double oper2		// Second number to add
)
{
  fixed_point result(oper2);	// Result of the addition

  result += oper1;
  return (result);
}

/********************************************************  
 * double +  fixed  -- Addition 			*
 *							*
 * Returns:						*
 *	The result of the addition			*
 ********************************************************/
inline fixed_point operator + (
    double oper1, 		// First number to add
    const fixed_point& oper2	// Second number to add
)
{
  fixed_point result(oper1);	// Result of the addition

  result += oper2;
  return (result);
}

/********************************************************  
 * fixed -  fixed  -- subtraction 			*
 *							*
 * Returns:						*
 *	The result of the subtraction			*
 ********************************************************/
inline fixed_point operator - (
    const fixed_point& oper1, 	// First part of subtraction
    const fixed_point& oper2	// Second part of subtraction
)
{
  fixed_point result;		// Result of the subtract

  result.value = oper1.value - oper2.value;
  return (result);
}

/********************************************************  
 * fixed -  double  -- subtraction 			*
 *							*
 * Returns:						*
 *	The result of the subtraction			*
 ********************************************************/
inline fixed_point operator - (
    const fixed_point& oper1, 	// First part of subtraction
    double oper2		// Second part of subtraction
)
{
    fixed_point result(oper2);	// Result of the subtract

    result += oper1;
    return (result);
}

/********************************************************  
 * double -  fixed  -- subtraction 			*
 *							*
 * Returns:						*
 *	The result of the subtraction			*
 ********************************************************/
inline fixed_point operator - (
    double oper1, 		// First part of subtraction
    const fixed_point& oper2	// Second part of subtraction
)
{
  fixed_point result(oper1);	// Result of the subtract

  result += oper2;
  return (result);
}

/********************************************************  
 * fixed *  fixed  -- multiplication 			*
 *							*
 * Returns:						*
 *	The result of the multiplication		*
 ********************************************************/
inline fixed_point operator * (
    const fixed_point& oper1, 	// First number to multiple
    const fixed_point& oper2	// Second number to multiple
)
{
  fixed_point result;		// Result of the multiply

  result.value = 
     int(double(oper1.value) * double(oper2.value) / double(SCALE));
  return (result);
}

/********************************************************  
 * fixed *  double  -- multiplication 			*
 *							*
 * Returns:						*
 *	The result of the multiplication		*
 ********************************************************/
inline fixed_point operator * (
    const fixed_point& oper1, 	// First number to multiple
    const double oper2		// Second number to multiple
)
{
   fixed_point result(oper2);	// Result of the multiply

   result *= oper1;
   return (result);
}

/********************************************************  
 * double *  fixed -- multiplication 			*
 *							*
 * Returns:						*
 *	The result of the multiplication		*
 ********************************************************/
inline fixed_point operator * (
    const double oper1, 		// First number to multiply
    const fixed_point& oper2		// Second number to multiply
)
{
   fixed_point result(oper1);		// Result of the multiply

   result *= oper2;
   return (result);
}

/********************************************************
 * fixed / fixed -- fixed point divide			*
 *							*
 * Returns:						*
 * 	The result of the divide			*
 ********************************************************/
fixed_point operator / (
    const fixed_point &oper1, 	// First part of the divide
    const fixed_point &oper2	// Second part of the divide
) {
    fixed_point result;		// Result of the divide

    result.value = 
	int(double(oper1.value) / double(oper2.value) * double(SCALE));
    return (result);
}

/********************************************************
 * double / fixed -- divide a double by a fixed point	*
 *		number.					*
 *							*
 * Returns:						*
 *	The result of the divide.			*
 ********************************************************/
inline fixed_point operator / (
    const double  &oper1, 	// The first part of the divide
    const fixed_point &oper2	// The second part of the divide
) {
    fixed_point result(oper1);	// The result of the divide

    result /= oper2;
    return (result);
}

/********************************************************
 * fixed / double -- divide a fixed point number by a 	*
 *	floating point number.				*
 *							*
 * Returns:						*
 *	The result of the divide			*
 ********************************************************/
inline fixed_point operator / (
    const fixed_point  &oper1, 	// f of "f / d"
    const double &oper2		// d of "f / d"
) {
    fixed_point result(oper2);	// Result of the divide

    result /= oper1;
    return (result);
}

/********************************************************
 * fixed == fixed -- check to see if two fixed point	*
 *			numbers are equal		*
 *							*
 * Returns						*
 *	result of the comparison			*
 ********************************************************/
inline int operator == (
    const fixed_point& oper1, 	// One fixed point number
    const fixed_point& oper2	// The other fixed point number
) {
    return (oper1.value == oper2.value);
}

/********************************************************
 * fixed != fixed -- check to see if two fixed point	*
 *			numbers are not equal		*
 *							*
 * Returns						*
 *	result of the comparison			*
 ********************************************************/
inline int operator != (
    const fixed_point& oper1, 	// One fixed point number
    const fixed_point& oper2	// The other fixed point number
)
{
    return (oper1.value != oper2.value);
}

/********************************************************
 * - fixed -- negative operator on fixed point number	*
 *							*
 * Returns:						*
 *	Result.						*
 ********************************************************/
inline fixed_point operator - (const fixed_point& oper1)
{
  fixed_point result(oper1);	// Result of the - operation

  result.value = -result.value;
  return (result);
}

/********************************************************
 * + fixed -- positive operator on fixed point number	*
 *							*
 * Returns:						*
 *	Result.						*
 ********************************************************/
inline fixed_point operator + (
    const fixed_point& oper1
)
{
  fixed_point result(oper1);	// Result of the + operation

  return (result);
}

/********************************************************
 * out_file << fixed_point -- write fixed point number	*
 *							*
 * Returns						*
 *	Reference to the output file.			*
 ********************************************************/
inline ostream &operator << (
   ostream &out_file, 		// File to write to
   const fixed_point &number	// Number to write
)
{
    out_file << (double(number.value) / double(SCALE));
    return (out_file);
}

/********************************************************
 * istream >> complex -- read a complex number		*
 *							*
 * Parameters						*
 *	in_file -- file to read				*
 *	number -- place to put the number		*
 *							*
 * Returns						*
 *	reference to the input file			*
 ********************************************************/
istream &operator >> (
    istream &in_file, 	// File to write to
    fixed_point &number	// Number to write
)
{
    double read_value;	// Value read from the input

    in_file.ipfx(1);	// Tell the i/o system we are reading formatted
    in_file >> ws;	// Skip whitespace

    if (in_file.bad()) return (in_file);	

    in_file >> read_value;	// Get character after whitespace
    if (in_file.bad()) return (in_file);

    number.value = int(read_value / double(SCALE));
    return (in_file);
}

main()
{
    fixed_point n1, n2;	// Two numbers

    n1.set(2.4);
    n2.set(2.0);

    cout << n1 << " + " << n2 << " = " << (n1 + n2) << '\n';
    cout << n1 << " - " << n2 << " = " << (n1 - n2) << '\n';
    cout << n1 << " * " << n2 << " = " << (n1 * n2) << '\n';
    cout << n1 << " / " << n2 << " = " << (n1 / n2) << '\n';

    return (0);
}
