/********************************************************
 * array -- array with bounds checking.			*
 *							*
 * Programming Problem: 24-2.				*
 ********************************************************/
#ifndef _BOUND_ARRAY_H_	/* Prevent double includes */
#define _BOUND_ARRAY_H_

// Class to define an out of bounds condition
class bounds_error {
    public:
        int upper;	// Upper bound
	int lower;	// Lower bound
	int index;	// Index that's out of bounds

	bounds_error(int i_upper, int i_lower, int i_index) {
	    upper = i_upper;
	    lower = i_lower;
	    index = i_index;
	}
	// Destructor defaults
	// Copy constructor defaults
	// Assignment operator defaults
};

template<class element>
class bound_array {
    private:
        element *data;	// The array's data
    public:
        const int lower;	// Lower bound
	const int upper;	// Upper array bound
        bound_array(const int i_lower, const int i_upper) :
	    lower(i_lower), upper(i_upper) {
	    data = new element[upper - lower + 1];
	}
	virtual ~bound_array(void) {
	    delete data;
	    data = NULL;
	}
    private:
        // No copy constructor
	bound_array(const bound_array &);

	// No assignment operator
	bound_array operator =(const bound_array &);
    public:
	element &operator[] (int index) {
	    if ((index < lower) || (index > upper)) {
		bounds_error error(upper, lower, index);
	        throw(error);
	    }
	    return (data[index - lower]);
	}
};
	    
#endif /* _BOUND_ARRAY_H_ */
