/********************************************************
 * words -- Module to decompose a file into words	*
 *							*
 * Programming Problem: 26-1				*
 *							*
 * Words class member functions:			*
 *	get_word -- remove the next word from the file	*
 ********************************************************/
#include <iostream.h>
#include <fstream.h>
#include <iomanip.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>

#include "words.h"
/********************************************************
 * get_word -- get the next word.			*
 *							*
 * If echo has been set, echo the stuff before the 	*
 * word to the screen. WARNING: The word is never 	*
 * echoed.						*
 *                                                      *
 * Parameters                                           *
 *      name -- name of the file to scan                *
 ********************************************************/
void words::get_word(
    char *whitespace,	// Place to put the whitespace before the word
    char *word		// Place to put the word
)
{
    char ch;            // current character 

    *whitespace = '\0';
    *word = '\0';
    // scan past the whitespace 
    while (1) {
        ch = *line_ptr;	// Get next character
	if (ch != '\0')
	    ++line_ptr;

	if (isalpha(ch)) {
	    *whitespace = '\0';
	    break;
	}
	    
	*whitespace = ch;
	++whitespace;
	if (ch == '\0')
	    return;
    }

    *word = ch;
    ++word;

    while (1) {
	ch = *line_ptr;
	if (ch != '\0')
	    ++line_ptr;

	if (!isalpha(ch)) {
	    *word = '\0';
	    --line_ptr;
	    break;
	}
	*word = ch;
	++word;
    }
}
