/********************************************************
 * words -- class to decompose a file into words.	*
 *							*
 * Member functions:					*
 *	next_line -- read the next line			*
 *	out_line -- write the line to the output.	*
 *	get_word -- extract a word from the line	*
 ********************************************************/
const int LINE_MAX = 512;		// Longest possible line
class words {
    private:
        char line[LINE_MAX];	// Line from the input
	int echo;		// Echo flag (If set, write line to output)
	istream *in_file;	// Input file
	char *line_ptr;		// Current location in the line
    public:
        words(istream &i_in_file, const int i_echo = 0) {
	    in_file = &i_in_file;
	    echo = i_echo;
	    line_ptr = NULL;
	}
	// Destructor defaults
	// Copy constructor defaults
	// Assignment operator defaults
	void get_word(
	    char *whitespace,	// Place to put the whitespace before the word
	    char *word		// Place to put the word
	);
	int next_line(void) {	// Moves up one line
	    line[0] = '\0';
	    in_file->getline(line, sizeof(line));
	    line_ptr = line;
	    return (!in_file->eof());
	}

	// Write out current line
	void out_line(ostream &out_file) {
	    out_file << line << '\n';
	}
};
